src/Solution/Web/ViewModels/Unregistered/UnregisteredAddEditViewModel.cs
using MyApp.Web.Resources;
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Globalization;
using System.Web.Security;
using MyApp.Business.DomainObjects.Models;
using System.Web.Mvc;

namespace MyApp.Web.ViewModels
{

    public class UnregisteredAddEditViewModel : BaseViewModel
    {

        public string EncryptedId { get; set; }

        [Required(ErrorMessageResourceName = "requiredfield", ErrorMessageResourceType = typeof(EVAResource))]
        [Display(Name = "UnregisteredGroupName", ResourceType = typeof(EVAResource))]
        [StringLength(100)]
        public string Name { get; set; }

        [Display(Name = "active", ResourceType = typeof(EVAResource))]
        public Boolean IsActive { get; set; }



        public UnregisteredAddEditViewModel()
        {
        }
    }

}

src/Solution/Web/ViewModels/Unregistered/UnregisteredGroupCodesViewModel.cs
using MyApp.Web.Resources;
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Globalization;
using System.Web.Security;
using MyApp.Business.DomainObjects.Models;
using System.Web.Mvc;

namespace MyApp.Web.ViewModels
{

    public class UnregisteredGroupCodesViewModel :BaseViewModel
    {

        public int TotalRequestedUnregisteredCodes { get; set; }

        public int MaxRequestedUnregisteredCodes { get; set; }

        [Required(ErrorMessageResourceName = "requiredfield", ErrorMessageResourceType = typeof(EVAResource))]
        [Range(1,9999)]
        [Display(Name = "requestedunregisteredcodes", ResourceType = typeof(EVAResource))]
        public int? Newlyrequested { get; set; }

        public string EncryptedId { get; set; }

        public Boolean CanAddMoreUnregistered { get; set; }



        public UnregisteredGroupCodesViewModel()
        {
        }
    }

}

src/Solution/Web/ViewModels/Unregistered/UnregisteredIndexViewModel.cs
using MyApp.Web.Resources;
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Globalization;
using System.Web.Security;
using MyApp.Business.DomainObjects.Models;
using System.Web.Mvc;

namespace MyApp.Web.ViewModels
{

    public class UnregisteredIndexViewModel : BaseViewModel
    {

        public List<UnregisteredListViewModel> ListOfUnregistered { get; set; }

        public UnregisteredIndexViewModel()
        {
        }
    }

}

src/Solution/Web/ViewModels/Unregistered/UnregisteredListViewModel.cs
using MyApp.Web.Resources;
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Globalization;
using System.Web.Security;
using MyApp.Business.DomainObjects.Models;
using System.Web.Mvc;

namespace MyApp.Web.ViewModels
{

    public class UnregisteredListViewModel 
    {

        public string EncryptedId { get; set; }

        public string Name { get; set; }

        public int UnregisteredCodesRequested { get; set; }

        public int TotalCodesAvailable { get; set; }

        public Boolean CanDownloadPDF { get; set; }

        public Boolean CanAllocateMore { get; set; }

        public Boolean CanDeleteUnregisteredGroup { get; set; }

        public Boolean DoesZoneHaveEngagements { get; set; }


        public UnregisteredListViewModel()
        {
        }
    }

}

src/Solution/Web/Controllers/UnregisteredController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Transactions;
using System.Web;
using System.Web.Mvc;
using System.Web.Security;
using MvcContrib;
using MyApp.Business.Services;
using MyApp.DAL.Repository;
using MyApp.Web.ViewModels;
using WebMatrix.WebData;
using OpenPlatform.General.Extensions;
using MyApp.Business.DomainObjects.Models;
using OpenPlatform.General.Encryption;
using System.Security;
using System.Text;
using System.Security.Cryptography;

namespace MyApp.Web.Controllers
{

    [Authorize(Roles = "DEV,SUPERUSER")]
    public class UnregisteredController : BaseController
    {
        private IAccountService _AccountService;
        private IConfiguration _Configuration;
        private ILog _Log;
        private IUnregisteredService _UnregisteredService;
        private IQRCodeService _QRCodeService;


        public UnregisteredController(IAccountService accountService, IConfiguration configuration, ILog log, IUnregisteredService unregisteredservice, IQRCodeService qrcodeservice)
        {
            _AccountService = accountService;
            _Configuration = configuration;
            _Log = Log;
            _UnregisteredService = unregisteredservice;
            _QRCodeService = qrcodeservice;
        }

        [HttpGet]
        public ActionResult Index()
        {
            Log.Debug(string.Format("UnregisteredController ActionResult Index() {0} ", ""));

            UnregisteredIndexViewModel viewmodel = new UnregisteredIndexViewModel();

            viewmodel.ListOfUnregistered = new List<UnregisteredListViewModel>();

            foreach (Unregistered item in _UnregisteredService.GetUnregisteredOrderedByName(_AccountService.GetUserCache(GetLoggedInUserUserName()).Id, true))
            {
                UnregisteredListViewModel model = new UnregisteredListViewModel()
                {
                    Name = item.Name,
                    EncryptedId = item.Id.Encrypt(),
                    UnregisteredCodesRequested = item.UnregisteredCodeIndex,
                    TotalCodesAvailable = item.MaxUnregisteredCodesAllowed,
                    DoesZoneHaveEngagements = (1 > 0 ? true : false),
                    CanDownloadPDF = (item.UnregisteredCodeIndex > 0 ? true : false),
                    CanAllocateMore = item.UnregisteredCodeIndex < item.MaxUnregisteredCodesAllowed,
                    CanDeleteUnregisteredGroup = !_UnregisteredService.DoesUnregisteredGroupHaveAnyEngagements(item.Id)
                };

                model.DoesZoneHaveEngagements = true;
                viewmodel.ListOfUnregistered.Add(model);
            }

            return View(viewmodel);

        }


        [HttpGet]
        public ActionResult AddEditUnregistered(string encid)
        {
            Log.Debug(string.Format("UnregisteredController ActionResult AddEditUnregistered() {0} ", encid));

            Unregistered selectedunregisteredgroup = new Unregistered() { IsActive = true };

            if (encid.IsNotNullOrEmpty())
            {
                selectedunregisteredgroup = _UnregisteredService.GetUnregisteredById(encid.DecryptToInt());
            }

            UnregisteredAddEditViewModel viewmodel = new UnregisteredAddEditViewModel();
            viewmodel.EncryptedId = selectedunregisteredgroup.Id.Encrypt();
            viewmodel.IsActive = selectedunregisteredgroup.IsActive;
            viewmodel.Name = selectedunregisteredgroup.Name;

            return View(viewmodel);

        }


        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult AddEditUnregistered(UnregisteredAddEditViewModel viewmodel)
        {
            Log.Debug(string.Format("UnregisteredController ActionResult AddEditUnregistered() {0} ", ""));

            BusinessEnum.UnregisteredAdd addresult = BusinessEnum.UnregisteredAdd.Fail;

            if (ModelState.IsValid)
            {

                // edit
                if (viewmodel.EncryptedId.DecryptToInt() > 0)
                {
                    Unregistered editedgroup = _UnregisteredService.GetUnregisteredById(viewmodel.EncryptedId.DecryptToInt());
                    editedgroup.IsActive = viewmodel.IsActive;
                    editedgroup.Name = viewmodel.Name;

                    addresult = _UnregisteredService.Update(editedgroup);
                }

                // add
                if (viewmodel.EncryptedId.DecryptToInt() == 0)
                {
                    Unregistered addedunregistered = new Unregistered();
                    addedunregistered.IsActive = viewmodel.IsActive;
                    addedunregistered.Name = viewmodel.Name.TrimCheckForNull();
                    addedunregistered.UserProfileId = _AccountService.GetUserCache(GetLoggedInUserUserName()).Id;

                    addresult = _UnregisteredService.Add(addedunregistered);

                }

                if (addresult == BusinessEnum.UnregisteredAdd.DuplicateName)
                {
                    viewmodel.Feedbackmessage = MyApp.Web.Resources.EVAResource.groupalreadyexists;
                }
                else if (addresult == BusinessEnum.UnregisteredAdd.Fail)
                {
                    viewmodel.Feedbackmessage = MyApp.Web.Resources.EVAResource.failedtocompleterequest;
                }
                else
                {
                    return RedirectToAction("Index");
                }

            }

            return View(viewmodel);
        }




        [HttpGet]
        public ActionResult DownloadUnregisteredGroupPDF(string encid)
        {
            Log.Debug(string.Format("UnregisteredController ActionResult DownloadUnregisteredGroupPDF() {0} ", encid));

            Unregistered selectedgroup = _UnregisteredService.GetUnregisteredById(encid.DecryptToInt());

            StringBuilder sb = new StringBuilder();

            var cd = new System.Net.Mime.ContentDisposition
            {
                FileName = String.Format("Unreg_{0}.zip", selectedgroup.Id),
                Inline = false,
            };

            Response.Clear();
            Response.AppendHeader("Content-Disposition", cd.ToString());



            return File(_QRCodeService.GenerateMultiPartPDFZipFOrGroupUnregistered(Server.MapPath("~/") + "Content\\Template\\Unregistered.doc", selectedgroup, GetBaseURL()).ToArray(), "application/zip");
           // return File(_QRCodeService.GeneratePDFForGroupUnregistered(Server.MapPath("~/") + "Content\\Template\\Unregistered.doc", selectedgroup, GetBaseURL()).ToArray(), "application/pdf");


        }




        [HttpGet]
        public ActionResult DeleteUnregistered(string encid)
        {
            Log.Debug(string.Format("UnregisteredController ActionResult DeleteUnregistered() {0} ", encid));

            _UnregisteredService.DeleteByUnregisteredId(encid.DecryptToInt());

            return RedirectToAction("Index");
        }




        [HttpGet]
        public ActionResult GenerateUnregisteredGroupCodes(string encid)
        {
            Log.Debug(string.Format("UnregisteredController ActionResult GenerateUnregisteredGroupCodes() {0} ", encid));

            Unregistered selectedgroup = _UnregisteredService.GetUnregisteredById(encid.DecryptToInt());

            UnregisteredGroupCodesViewModel model = new UnregisteredGroupCodesViewModel();

            model.TotalRequestedUnregisteredCodes = selectedgroup.UnregisteredCodeIndex;

            model.MaxRequestedUnregisteredCodes = selectedgroup.MaxUnregisteredCodesAllowed;

            model.CanAddMoreUnregistered = _UnregisteredService.IsUnregisteredAmountRequestBelowMaxAllowed(0, selectedgroup);

            model.EncryptedId = encid.DecryptToInt().Encrypt();

            return View(model);

        }





        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult GenerateUnregisteredGroupCodes(UnregisteredGroupCodesViewModel viewmodel)
        {
            Log.Debug(string.Format("UnregisteredController ActionResult GenerateUnregisteredGroupCodes() {0} ", ""));

            if (ModelState.IsValid)
            {
                Unregistered selectedgroup = _UnregisteredService.GetUnregisteredById(viewmodel.EncryptedId.DecryptToInt());

                BusinessEnum.UnregisteredRequestIndex result = _UnregisteredService.UpdateUnregisteredRequestIndex(viewmodel.Newlyrequested.Value, selectedgroup);

                if (result == BusinessEnum.UnregisteredRequestIndex.TooMuchRequested)
                {
                    ModelState.AddModelError("Newlyrequested", String.Format(Resources.EVAResource.toomuchrequested, _Configuration.MaxUnregisteredZonesAllowedPerRequest));
                }
                else if (result == BusinessEnum.UnregisteredRequestIndex.ExceedMax)
                {
                    ModelState.AddModelError("Newlyrequested", Resources.EVAResource.exceeededmaxunregisteredrequested);
                }
                else if (result == BusinessEnum.UnregisteredRequestIndex.Success)
                {
                    return RedirectToAction("GenerateUnregisteredGroupCodes", new { encid = viewmodel.EncryptedId });
                }
                else
                {
                    viewmodel.Feedbackmessage = MyApp.Web.Resources.EVAResource.unabletoprocessrequest;
                }
            }

            return View(viewmodel);

        }


        //[HttpGet]
        //public ActionResult ShowEngagementsByZone(string zoneid)
        //{
        //    Log.Debug(string.Format("UnregisteredController ActionResult ShowEngagementsByZone() {0} ", zoneid));

        //    EngagementListViewModel viewmodel = new EngagementListViewModel();


src/Solution/Web/Views/Unregistered/AddEditUnregistered.cshtml
@model MyApp.Web.ViewModels.UnregisteredAddEditViewModel

@{
    ViewBag.Title = @MyApp.Web.Resources.EVAResource.WebsiteTitle;
}

@Html.Partial("_NavSuperUser", MyApp.Web.Resources.EVAResource.unregisteredCodes)

<h2>@MyApp.Web.Resources.EVAResource.addeditunregistered</h2>


@using (Html.BeginForm("AddEditUnregistered", "Unregistered", FormMethod.Post, new { @class = "form-horizontal" }))
{
    @Html.AntiForgeryToken()

    @Html.Partial("_Feedback", Model.Feedbackmessage ?? string.Empty);

    <div class="well">

        <div class="form-group">
            @Html.LabelFor(x => x.Name)
                @Html.TextBoxFor(m => m.Name, new { MaxLength = "100" })
                @Html.ValidationMessageFor(m => m.Name)
        </div>

        <div class="form-group">
            <div class="col-sm-offset-2 col-sm-10">
                @Html.SubmitButton(@MyApp.Web.Resources.EVAResource.save)
                @Html.HiddenFor(m => m.EncryptedId)
                @Html.HiddenFor(m => m.IsActive)
            </div>
        </div>

    </div>
}



<script src="~/Scripts/op.copypaste.js" type="text/javascript"></script>

src/Solution/Web/Views/Unregistered/GenerateUnregisteredGroupCodes.cshtml
@model MyApp.Web.ViewModels.UnregisteredGroupCodesViewModel

@{
    ViewBag.Title = @MyApp.Web.Resources.EVAResource.WebsiteTitle;
}
GenerateUnregisteredGroupCodes
@Html.Partial("_NavSuperUser", MyApp.Web.Resources.EVAResource.unregisteredCodes)

<h2>@MyApp.Web.Resources.EVAResource.unregidsteredcodes</h2>


@if (Model.CanAddMoreUnregistered)
{
    using (Html.BeginForm("GenerateUnregisteredGroupCodes", "Unregistered", FormMethod.Post, new { @class = "form-horizontal" }))
    {
        @Html.AntiForgeryToken()

        @Html.Partial("_Feedback", Model.Feedbackmessage ?? string.Empty);

        <p>@MyApp.Web.Resources.EVAResource.totunregrequested : @Model.TotalRequestedUnregisteredCodes/@Model.MaxRequestedUnregisteredCodes</p>

        <div class="well">

            <div class="form-group">
                @Html.LabelFor(x => x.Newlyrequested)
                @Html.TextBoxFor(m => m.Newlyrequested, new { MaxLength = "4" })
                @Html.ValidationMessageFor(m => m.Newlyrequested)
            </div>

            <div class="form-group">
                <div class="col-sm-offset-2 col-sm-10">
                    @Html.SubmitButton(@MyApp.Web.Resources.EVAResource.request)
                    @Html.HiddenFor(m => m.EncryptedId)
                    @Html.HiddenFor(m => m.MaxRequestedUnregisteredCodes)
                    @Html.HiddenFor(m => m.TotalRequestedUnregisteredCodes)
                    @Html.HiddenFor(m=>m.CanAddMoreUnregistered)
                </div>
            </div>

        </div>
    }
}



<script src="~/Scripts/op.copypaste.js" type="text/javascript"></script>

src/Solution/Web/Views/Unregistered/Index.cshtml
@model MyApp.Web.ViewModels.UnregisteredIndexViewModel
@using OpenPlatform.General.Extensions;
@using MyApp.Web.ViewModels;

@{
    ViewBag.Title = @MyApp.Web.Resources.EVAResource.WebsiteTitle;
}

@Html.Partial("_NavSuperUser", MyApp.Web.Resources.EVAResource.unregisteredCodes)

@Html.ActionLink(MyApp.Web.Resources.EVAResource.addnewunreggroup, "AddEditUnregistered", null, new { @class = "btn btn-default btn-lg", role = "button" })

@if (Model.ListOfUnregistered == null || Model.ListOfUnregistered.Count == 0)
{
    @Html.Partial("_NoRecordsExist", null);
}
else
{
    <div class="table-responsive">
        <table class="table-striped">
            <tr class="tableheaderrow">
                <th>Name</th>
                <th>Total Claimed</th>
                <th>Action</th>
            </tr>
            <tbody>
                @foreach (UnregisteredListViewModel item in Model.ListOfUnregistered)
                {
                    <tr>
                        <td>
                            @item.Name.TrimforUI(25, true)
                        </td>
                        <td>
                            @item.UnregisteredCodesRequested/@item.TotalCodesAvailable
                        </td>

                        <td>
                            @Html.ActionLink(@MyApp.Web.Resources.EVAResource.edit, "AddEditUnregistered", new { encid = @item.EncryptedId }, new { @class = "btn btn-link", role = "button" })

                            @if (@item.CanAllocateMore)
                            {
                                @Html.ActionLink(@MyApp.Web.Resources.EVAResource.generateunregisteredcodes, "GenerateUnregisteredGroupCodes", new { encid = @item.EncryptedId }, new { @class = "btn btn-link", role = "button" })
                            }
                            @if (@item.CanDownloadPDF)
                            {
                                @Html.ActionLink(@MyApp.Web.Resources.EVAResource.getunregisteredpdf, "DownloadUnregisteredGroupPDF", new { encid = @item.EncryptedId }, new { @class = "btn btn-link", role = "button", })
                            }

                            @if (@item.CanDeleteUnregisteredGroup)
                            {
                            @Html.ActionLink(@MyApp.Web.Resources.EVAResource.delete, "DeleteUnregistered", new { encid = @item.EncryptedId }, new { @class = @item.DoesZoneHaveEngagements ? "btn btn-link" : "btn btn-link disabled", role = "button", title = @item.DoesZoneHaveEngagements ? @MyApp.Web.Resources.EVAResource.mustdeleteenagegementsfirst : "" })
                            }

                        </td>
                    </tr>
                }
            </tbody>
        </table>
    </div>
}